/*
 * TOKENLST.C - C RUNTIME LIBRARY
 *
 *  This file is part of DOSZIP
 *  Copyright (c) 1996 Hjort Nidudsson.
 */

#define MAXLABEL	32
#define MAXTOKEN	1000

char token[MAXTOKEN][MAXLABEL] = {
	"%OUT",
	".ALPHA",
	".CODE",
	".CONST",
	".CREF",
	".DATA",
	".DATA?",
	".ERR",
	".ERR1",
	".ERR2",
	".ERRB",
	".ERRDEF",
	".ERRDIF",
	".ERRE",
	".ERRIDN",
	".ERRNB",
	".ERRNDEF",
	".ERRNZ",
	".FARDATA",
	".FAREDATA?",
	".LALL",
	".LFCOND",
	".LIST",
	".MODEL",
	".MSFLOAT",
	".RADIX",
	".SALL",
	".SEQ",
	".SFCOND",
	".STACK.",
	".TFCOND",
	".TYPE",
	".XALL",
	".XCREF",
	".XLIST",
	"aaa",
	"aad",
	"aam",
	"aas",
	"adc",
	"add",
	"ah",
	"al",
	"ALIGN",
	"and",
	"ASSUME",
	"ax",
	"bh",
	"bl",
	"bound",
	"bp",
	"bsf",
	"bsr",
	"bt",
	"btc",
	"btr",
	"bts",
	"bx",
	"BYTE",
	"call",
	"cbw",
	"cdq",
	"ch",
	"cl",
	"clc",
	"cld",
	"cli",
	"cmp",
	"cmps",
	"cmpsb",
	"COMM",
	"COMMENT",
	"CS",
	"cwd",
	"cwde",
	"cx",
	"daa",
	"das",
	"DB",
	"DD",
	"dec",
	"DF",
	"dh",
	"di",
	"div",
	"dl",
	"DOSSEG",
	"DQ",
	"DS",
	"DT",
	"DUP",
	"DW",
	"DWORD",
	"dx",
	"ELSE",
	"END",
	"ENDIF",
	"ENDM",
	"ENDP",
	"ENDS",
	"enter",
	"EQ",
	"EQU",
	"ES",
	"esc",
	"EVEN",
	"EXITM",
	"EXTRN",
	"f2xm1",
	"fa",
	"fabs",
	"fadd",
	"FAR",
	"fbld",
	"fbstp",
	"fchs",
	"fcom",
	"fcomp",
	"fcompp",
	"fcos",
	"fdiv",
	"fdivp",
	"fdivr",
	"fdivrp",
	"fiadd",
	"ficom",
	"ficomp",
	"fidiv",
	"fidivr",
	"fild",
	"fimul",
	"finit",
	"fist",
	"fistp",
	"fisub",
	"fisubr",
	"fld",
	"fld1",
	"fldcw",
	"fldl2e",
	"fldl2t",
	"fldlg2",
	"fldln2",
	"fldpi",
	"fldz",
	"fmul",
	"fmulp",
	"fpatan",
	"fprem",
	"fptan",
	"frndint",
	"FS",
	"fscale",
	"fsin",
	"fsincos",
	"fsqrt",
	"fst",
	"fstcw",
	"fstp",
	"fstsw",
	"fsub",
	"fsubp",
	"fsubr",
	"fsubrp",
	"ftst",
	"fwait",
	"fxam",
	"fxch",
	"fxtract",
	"fyl2x",
	"fyl2xp1",
	"GE",
	"GROUP",
	"GS",
	"GT",
	"HIGH",
	"hlt",
	"idiv",
	"IF",
	"IF"",
	"IF"",
	"IF"",
	"IF"EF",
	"IFDIF",
	"IFE",
	"IFIDN",
	"IFNB",
	"IFNDEF",
	"imul",
	"in",
	"inc",
	"INCLUDE",
	"INCLUDELIB",
	"ins",
	"int",
	"into",
	"IP",
	"iret",
	"iretd",
	"IRP",
	"IRPC",
	"ja",
	"jae",
	"jb",
	"jbe",
	"jc",
	"jcxz",
	"je",
	"jexcz",
	"jg",
	"jge",
	"jl",
	"jle",
	"jmp",
	"jna",
	"jnae",
	"jnb",
	"jnbe",
	"jnc",
	"jne",
	"jng",
	"jnge",
	"jnl",
	"jnle",
	"jno",
	"jnp",
	"jns",
	"jnz",
	"jo",
	"jp",
	"jpe",
	"jpo",
	"js",
	"jz",
	"LABEL",
	"lahf",
	"lds",
	"LE",
	"lea",
	"leave",
	"LENGTH",
	"les",
	"lfs",
	"lgs",
	"LOCAL",
	"lock",
	"lods",
	"lodlb",
	"lodsw",
	"loop",
	"loope",
	"loopne",
	"loopnz",
	"loopz",
	"LOW",
	"lss",
	"LT",
	"MACRO",
	"MASK",
	"MOD",
	"mov",
	"movs",
	"movsb",
	"movsw",
	"movsx",
	"movzx",
	"mul",
	"NAME",
	"NE",
	"NEAR",
	"neg",
	"nop",
	"not",
	"OFFSET",
	"or",
	"ORG",
	"out",
	"outs",
	"PAGE",
	"pop",
	"popa",
	"popad",
	"popd",
	"popf",
	"popfd",
	"PROC",
	"PTR",
	"PUBLIC",
	"PURGE",
	"push",
	"pusha",
	"pushad",
	"pushd",
	"pushf",
	"pushfd",
	"rcl",
	"rcr",
	"RECORD",
	"rep",
	"repe",
	"repne",
	"repnz",
	"REPT",
	"repz",
	"ret",
	"retf",
	"retn",
	"rol",
	"ror",
	"sahf",
	"sal",
	"sar",
	"sbb",
	"scas",
	"scasb",
	"scasw",
	"SEG",
	"SEGMENT",
	"set",
	"shl",
	"shld",
	"SHORT",
	"shr",
	"shrd",
	"si",
	"SIZE",
	"sp",
	"SS",
	"stc",
	"std",
	"sti",
	"stos",
	"stosb",
	"stosw",
	"STRUC",
	"sub",
	"SUBTTL",
	"test",
	"THIS",
	"TITLE",
	"ToadHall",
	"wait",
	"WIDTH",
	"WORD",
	"xchg",
	"xlat",
	"xor",
/*(347)*/
	"_TEXT",
	"_DATA",
	"_BSS",
	"DGROUP",
	"PASCAL",
	"USES",
	"ARG",
/* Macro */
	"TRUE",
	"FALSE",
	"DIST",
	"DPTR",
	"PTRSIZE",
	"CODESIZE",
	"DATASIZE",

	"PD",
	"MLDS",
	"MLES",
	"MMOV",
	"MPUSH",
	"MPOP",

	"PF",
	"FPTR",
	"RETX",

	"IFND",
	"IFFD",
	"DBUG",

	"PPROC",
	"PEND",

	"LOCDATA",
	"GLOBDATA",
	"INITPROC",
	"EXITPROC",

	"clib.inc",
	"dialog.inc",
	"_dtypes.inc",
	"_file.inc",
	"alloc.inc",
	"bios.inc",
	"clib.inc",
	"clibss.inc",
	"color.inc",
	"console.inc",
	"cursor.inc",
	"dialog.inc",
	"dir.inc",
	"dos.inc",
	"errno.inc",
	"ifsmgr.inc",
	"io.inc",
	"ios.inc",
	"kbd.inc",
	"keyb.inc",
	"macro.inc",
	"model.inc",
	"mouse.inc",
	"rect.inc",
	"stdio.inc",
	"stdsc.inc",
	"string.inc",
	"tdialog.inc",
	"time.inc",
	"twindow.inc",
	"unzip.inc",
	"wchar.inc",
	"wsub.inc",

	"",
};